; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
; Sending mail with attach in FASM
;         Created by Ct757
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;    ,      
;   SMTP- (   smtp.mail.ru)
;  ,   ,      ,
;    ,      
; base64,          
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

format PE GUI 4.0
entry start

  include 'include\win32a.inc'

section '.code' code readable writeable executable

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;       SMTP-,       RFC
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

  smtp_server  db '194.67.23.111',0				    ; IP- smtp.mail.ru

  helo_0       db 'HELO 0',13,10				    ;  helo
  helo_0_sz    = $ - helo_0					    ;

  mail_fr      db 'MAIL FROM: stealth-samurai@mail.ru',13,10			;   
  mail_fr_sz   = $ - mail_fr					    ;

  rcpt_to      db 'RCPT TO: stealth-samurai@mail.ru',13,10		   ;  
  rcpt_to_sz   = $ - rcpt_to					    ;

  data_        db 'DATA',13,10					    ;  data
  data_sz      = $ - data_					    ;


; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;    
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

  message      db 'From: Bill Gates <stealth-samurai@mail.ru>',13,10,\				    ;  
		  'Subject: Test MESSAGE',13,10,\					; 
		  'To: TEST <stealth-samurai@mail.ru>',13,10,\				       ; 
		  'MIME-Version: 1.0',13,10,\						;  MIME
		  'Content-Type: multipart/mixed;',13,10,\				;  
		  ' boundary="--ct757"',13,10,13,10,\					; 
		  '----ct757',13,10,\
		  'Content-Type: text/plain; charset=Windows-1251',13,10,\		; : ,
		  'Content-Transfer-Encoding: 8bit',13,10,13,10,\			;  Win-1251
		  'Hello, this is the test message with attachment.',13,10,13,10,\	;  
		  '----ct757',13,10,\
		  'Content-Type: application/octet-stream; name="test.rar"',13,10,\	; : 
		  'Content-Disposition: attachment; filename="test.rar"',13,10,\	;   - test.rar
		  'Content-Transfer-Encoding: base64',13,10,13,10			; ,  
											;   base64

  message_sz   = $ - message								;    
											;  ( !)


  file_name    db 'C:\test.rar',0							; ,   

  sock	       dd 0									;  
  file_h       dd 0									;  
  map_h        dd 0									;  
  map_addr     dd 0									;                                                                   ;
  al_mem       dd 0									;    

  buf_sz       = 100h									;  
  buf	       rb buf_sz								;   recv

  WSA	       WSADATA									; 
  sin	       sockaddr_in								; 


; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; base64 encoder without dictionary by RT Fishel
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; ebp = length, esi -> src buffer, edi -> dst buffer

  b64:
    .newline:
      call     b64.store_crlf

    .encode:
      push     (76 shr 2)+1
      pop      edx

    .outer:
      dec      edx
      je       b64.newline
      lodsd
      dec      esi
      inc      ebp
      bswap    eax
      mov      ecx,4

    .inner:
      rol      eax,6
      and      al,3Fh
      cmp      al,3Eh
      jb       b64.testchar
      shl      al,2
      sub      al,((3Eh shl 2)+'A'-'+') and 0FFh

    .testchar:
      sub      al,4
      cmp      al,'0'
      jnl      b64.store
      add      al,'A'+4
      cmp      al,'Z'
      jbe      b64.store
      add      al,'a'-'Z'-1

    .store:
      stosb
      dec      ebp
      loopne   b64.inner
      jne      b64.outer
      mov      al,'='
      rep      stosb
      ret

    .store_crlf:
      mov      ax,0A0Dh
      stosw
      ret


; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;      
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

  read_buf:
      invoke   recv,[sock],buf,buf_sz,esi
      ret


; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;   
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

  start:
      xor      esi,esi

      invoke   CreateFile,file_name,GENERIC_WRITE or GENERIC_READ,\	    ;  
		 esi,esi,OPEN_EXISTING,esi,esi				    ;  
      inc      eax							    ;  
      je       exit							    ;  
      dec      eax							    ;   ,
      mov      [file_h],eax						    ;   

      invoke   GetFileSize,eax,esi					    ;   
      mov      ebx,eax							    ;    ebx
      rol      eax,1							    ;    
									    ; (  , ..
									    ;  
									    ;  base64   )
      add      eax,message_sz						    ;   
									    ;   
									    ;  

      invoke   LocalAlloc,LMEM_FIXED,eax				    ;    
      test     eax,eax							    ;   -
      je       exit							    ; , 
      mov      [al_mem],eax						    ;  

      mov      edi,eax							    ;   
      mov      esi,message						    ; 
      mov      ecx,message_sz						    ;   
      rep      movsb							    ; 

      xor      esi,esi

      invoke   CreateFileMapping,[file_h],esi,PAGE_READWRITE,esi,ebx,esi    ;  file mapping
      test     eax,eax							    ;  
      je       clean_exit3						    ;  
      mov      [map_h],eax						    ;   ok,  

      invoke   MapViewOfFile,eax,2,esi,esi,esi				    ;    
      test     eax,eax							    ;  
      je       clean_exit2						    ;  
      mov      [map_addr],eax						    ;   ok,
									    ;   

      mov      esi,eax							    ; , 
									    ;  
      mov      ebp,ebx							    ;   
      call     b64.encode						    ;   base64

      mov      ax,0A0Dh 						    ;  
      stosw								    ; 
      mov      ax,0A0Dh 						    ; 
      stosw								    ; CRLF
      mov      al,'.'							    ; .
      stosb								    ; CRLF
      mov      ax,0A0Dh 						    ;
      stosw								    ;

      mov      eax,edi							    ;  
      sub      eax,[al_mem]						    ;  ,
      mov      ebx,eax							    ;     ebx

      xor      esi,esi

      invoke   WSAStartup,101h,WSA					    ;  winsock
      test     eax,eax							    ;  
      jne      clean_exit1						    ;  

      invoke   socket,AF_INET,SOCK_STREAM,0				    ;  
      inc      eax							    ; 
      je       clean_exit						    ; 
      dec      eax							    ; 
      mov      [sock],eax						    ;  ok - 
									    ;  

      push     smtp_server						    ;  
      call     [inet_addr]						    ; 

      mov      [sin.sin_family],AF_INET 				    ;  
      mov      [sin.sin_port],1900h					    ; sockaddr_in
      mov      [sin.sin_addr],eax					    ;

      invoke   connect,[sock],sin,10h					    ;   
      inc      eax							    ;  
      je       shtdown							    ; 

      call     read_buf 						    ;  
      inc      eax							    ; 
      je       shtdown							    ;  
      cmp      dword [buf],'220 '					    ;
      jne      shtdown							    ;

      invoke   send,[sock],helo_0,helo_0_sz,esi 			    ;  
      inc      eax							    ; ,
      je       shtdown							    ;  

      call     read_buf 						    ;   
      inc      eax
      je       shtdown
      cmp      dword [buf],'250 '
      jne      shtdown

      invoke   send,[sock],mail_fr,mail_fr_sz,esi			    ; MAIL FROM
      inc      eax
      je       shtdown

      call     read_buf
      inc      eax
      je       shtdown
      cmp      dword [buf],'250 '
      jne      shtdown

      invoke   send,[sock],rcpt_to,rcpt_to_sz,esi			    ; RCPT TO
      inc      eax
      je       shtdown

      call     read_buf
      inc      eax
      je       shtdown
      cmp      dword [buf],'250 '
      jne      shtdown

      invoke   send,[sock],data_,data_sz,esi				    ; DATA
      inc      eax
      je       shtdown

      call     read_buf
      inc      eax
      je       shtdown
      cmp      dword [buf],'354 '
      jne      shtdown

      invoke   send,[sock],[al_mem],ebx,esi				    ;  
      inc      eax
      je       shtdown

      call     read_buf

  shtdown:
      invoke   shutdown,[sock],esi					    ;  
      invoke   closesocket,[sock]					    ;   

  clean_exit:
      invoke   WSACleanup

  clean_exit1:
      invoke   UnmapViewOfFile,[map_addr]				    ;    

  clean_exit2:
      invoke   CloseHandle,[map_h]					    ;   

  clean_exit3:
      invoke   LocalFree,[al_mem]					    ;    
      invoke   CloseHandle,[file_h]					    ;  

  exit:
      invoke   ExitProcess,esi						    ;   


data import								    ; Import table

  library kernel32,'KERNEL32.DLL',\
	  wsock32,'WSOCK32.DLL'

  include 'include\APIA\kernel32.inc'
  include 'include\APIA\wsock32.inc'

end data